// A shim class needed between the Flex C++ scanner and
// the Bison C++ parser
// This should be included in place of the generated Flex header
#pragma once
#include "quant_c_parse.hpp"

#if !defined(yyFlexLexerOnce)
#include <FlexLexer.h>
#endif

namespace quant_c_compiler {
    class Scanner : public yyFlexLexer {
    public:
        Scanner(std::istream& arg_yyin, std::ostream& arg_yyout)
        : yyFlexLexer(arg_yyin, arg_yyout) {}

        Scanner(std::istream* arg_yyin = nullptr, std::ostream* arg_yyout = nullptr) : yyFlexLexer(arg_yyin, arg_yyout) {}

        // This method is the problem child;
        // it's defined in the auto-generated Flex scanner as
        // taking no arguments, when Bison needs it to
        // accept a pointer to capture a semantic value
        int lex(Parser::semantic_type *yylval);
    };

    std::string get_token_name(int value);
}
