#include "symbol_table/symbol_table.hpp"

using namespace symbol_table;

const char * EmptySTException::what() const noexcept {
    return "Attempted to perform an modifying operation on an empty stack";
}

DuplicateException::DuplicateException(std::string symbol_name) {
    message = std::string("Found a pre-existing symbol for \"") +
                          symbol_name +
                          "\" during an operation on the stack that expected no duplicates";
}

const char * DuplicateException::what() const noexcept {
    return message.c_str();
}

FailedLookupException::FailedLookupException(std::string symbol_name) {
    message = std::string("Failed to find \"") + symbol_name +
                      "\" in the stack";
 }

const char * FailedLookupException::what() const noexcept {

    return message.c_str();
}
