
quantum void QFT(quantum bool qubits[4]) {

    // Gates for qubit 0
    %H qubits[0];
    %PHASE(PI/2)+C(qubits[1]) qubits[0];
    %PHASE(PI/4)+C(qubits[2]) qubits[0];
    %PHASE(PI/8)+C(qubits[3]) qubits[0];

    // Gates for qubit 1
    %H qubits[1];
    %PHASE(PI/2)+C(qubits[2]) qubits[1];
    %PHASE(PI/4)+C(qubits[3]) qubits[1];

    // Gates for qubit 2
    %PHASE(PI/2)+C(qubits[3]) (%H qubits[2]);

    // Gate for qubit 3
    %H qubits[3];

    // Final set of swaps (this procedure reverses order of bits)
    qubits[0] <> qubits[3];
    qubits[1] <> qubits[2];

}

quantum int measure_QFT(bool start_value[4]) {

    // Copy starting values
    quantum bool test_qubits[4];
    for (int i = 0; i < 4; i++) {
        test_qubits[i] = start_value[i];
    }

    // Perform QFT
    QFT(test_qubits);

    // Measure results of QFT and store into int
    int result = 0;
    int mask = 0x01;
    for (int i = 0; i < 4; i++) {
        mask <<= i;
        result += mask * (%M test_qubits[i]);
    }

    return result;

}

void main() {

    bool test_bits[4];
    int test_int = hello_quantum(test_bits); // Result of QFT
}
